package perfmodel.wildfly.callstack;

import java.util.Collection;
import java.util.concurrent.ConcurrentHashMap;

public class ComponentRecord {
	private final String component;
	private String componentClass = null;
	private final ConcurrentHashMap<String, InterfaceRecord> interfaces = new ConcurrentHashMap<>();
	
	public ComponentRecord(String component) {
		this.component = component;
	}
	
	public void setComponentClass(String componentClass) {
		this.componentClass = componentClass;
	}
	
	public String getComponentClass() {
		return componentClass;
	}
	
	public String getComponentName() {
		return component;
	}
	
	public InterfaceRecord requireInterface(String interf) {
		InterfaceRecord record = interfaces.get(interf);
		if (record == null) {
			record = new InterfaceRecord(this, interf);
			if (interfaces.putIfAbsent(interf, record) != null) {
				// a different thread has changed it in the mean time
				record = interfaces.get(interf);
			}
		}
		return record;
	}
	
	public Collection<InterfaceRecord> getInterfaces() {
		return interfaces.values();
	}
}
